---
title: String.prototype.slice()
slug: Web/JavaScript/Reference/Global_Objects/String/slice
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - String
---
<div>{{JSRef}}</div>

<p>The <strong><code>slice()</code></strong> method extracts a section of a string and returns it as a new string, without modifying the original string.</p>

<div>{{EmbedInteractiveExample("pages/js/string-slice.html", "taller")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>str</var>.slice(<var>beginIndex</var>[, <var>endIndex</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>beginIndex</var></code></dt>
 <dd>
 <p>The zero-based index at which to begin extraction. If negative, it is treated as <code><var>str</var>.length + <var>beginIndex</var></code>. (For example, if <code><var>beginIndex</var></code> is <code>-3</code>, it is treated as <code><var>str</var>.length - 3</code>.) If <code><var>beginIndex</var></code> is not a number after {{jsxref('Number', 'Number(<var>beginIndex</var>)')}}, it is treated as <code>0</code>.</p>

 <p>If <code><var>beginIndex</var></code> is greater than or equal to <code><var>str</var>.length</code>, an empty string is returned.</p>
 </dd>
 <dt><code><var>endIndex</var></code> {{optional_inline}}</dt>
 <dd>
 <p>The zero-based index <em>before</em> which to end extraction. The character at this index will not be included.</p>

 <p>If <code><var>endIndex</var></code> is omitted or undefined, or greater than <code><var>str</var>.length</code>, <code>slice()</code> extracts to the end of the string. If negative, it is treated as <code><var>str</var>.length + <var>endIndex</var></code>. (For example, if <code><var>endIndex</var></code> is <code>-3</code>, it is treated as <code><var>str</var>.length - 3</code>.) If it is not undefined and not a number after <code>Number(<var>endIndex</var>)</code>, an empty string is returned.</p>

 <p>If <code><var>endIndex</var></code> is specified and <code><var>startIndex</var></code> is negative, <code><var>endIndex</var></code> should be negative, otherwise an empty string is returned. (For example, <code>slice(-3, 0)</code> returns <code>""</code>.)</p>

 <p>If <code><var>endIndex</var></code> is specified, and <code><var>startIndex</var></code> and <code><var>endIndex</var></code> are both positive or negative, <code><var>endIndex</var></code> should be greater than <code><var>startIndex</var></code>, otherwise an empty string is returned. (For example, <code>slice(-1, -3)</code> or <code>slice(3, 1)</code> returns <code>""</code>.)</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new string containing the extracted section of the string.</p>

<h2 id="Description">Description</h2>

<p><code>slice()</code> extracts the text from one string and returns a new string. Changes to the text in one string do not affect the other string.</p>

<p><code>slice()</code> extracts up to but not including <code><var>endIndex</var></code>. <code><var>str</var>.slice(1, 4)</code> extracts the second character through the fourth character (characters indexed <code>1</code>, <code>2</code>, and <code>3</code>).</p>

<p>As an example, <code><var>str</var>.slice(2, -1)</code> extracts the third character through the second to last character in the string.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_slice_to_create_a_new_string">Using <code>slice()</code> to create a new string</h3>

<p>The following example uses <code>slice()</code> to create a new string.</p>

<pre class="brush: js notranslate">let str1 = 'The morning is upon us.', // the length of str1 is 23.
    str2 = str1.slice(1, 8),
    str3 = str1.slice(4, -2),
    str4 = str1.slice(12),
    str5 = str1.slice(30);
console.log(str2)  // OUTPUT: he morn
console.log(str3)  // OUTPUT: morning is upon u
console.log(str4)  // OUTPUT: is upon us.
console.log(str5)  // OUTPUT: ""
</pre>

<h3 id="Using_slice_with_negative_indexes">Using <code>slice()</code> with negative indexes</h3>

<p>The following example uses <code>slice()</code> with negative indexes.</p>

<pre class="brush: js notranslate">let str = 'The morning is upon us.'
str.slice(-3)      // returns 'us.'
str.slice(-3, -1)  // returns 'us'
str.slice(0, -1)   // returns 'The morning is upon us'
</pre>

<p>This example counts backwards from the end of the string by <code>11</code> to find the start index and forwards from the start of the string by <code>16</code> to find the end index.</p>

<pre class="brush: js notranslate">console.log(str.slice(-11, 16)) // =&gt; "is u"</pre>

<p>Here it counts forwards from the start by <code>11</code> to find the start index and backwards from the end by <code>7</code> to find the end index.</p>

<pre class="brush: js notranslate">console.log(str.slice(11, -7)) // =&gt; " is u"</pre>

<p>These arguments count backwards from the end by <code>5</code> to find the start index and backwards from the end by <code>1</code> to find the end index.</p>

<pre class="brush: js notranslate">console.log(str.slice(-5, -1)) // =&gt; "n us"</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-string.prototype.slice', 'String.prototype.slice')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.String.slice")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("String.prototype.substr()")}}</li>
 <li>{{jsxref("String.prototype.substring()")}}</li>
 <li>{{jsxref("Array.prototype.slice()")}}</li>
</ul>
